Open CASCADE Technology 7.8.2.dev
GCE2d_MakeCircle Class Reference

This class implements the following algorithms used to create Circle from Geom2d. More...

#include <GCE2d_MakeCircle.hxx>

Inheritance diagram for GCE2d_MakeCircle:

Public Member Functions

 GCE2d_MakeCircle (const gp_Circ2d &C)
 creates a circle from a non persistent one.
 
 GCE2d_MakeCircle (const gp_Ax2d &A, const Standard_Real Radius, const Standard_Boolean Sense=Standard_True)
 A is the "XAxis" of the circle which defines the origin of parametrization. It is not forbidden to create a circle with Radius = 0.0 The status is "NegativeRadius" if Radius < 0.
 
 GCE2d_MakeCircle (const gp_Ax22d &A, const Standard_Real Radius)
 A is the local coordinate system of the circle which defines the origin of parametrization. It is not forbidden to create a circle with Radius = 0.0 The status is "NegativeRadius" if Radius < 0.
 
 GCE2d_MakeCircle (const gp_Circ2d &Circ, const Standard_Real Dist)
 Make a Circle from Geom2d <TheCirc> parallel to another Circ <Circ> with a distance <Dist>. If Dist is greater than zero the result is enclosing the circle <Circ>, else the result is enclosed by the circle <Circ>.
 
 GCE2d_MakeCircle (const gp_Circ2d &Circ, const gp_Pnt2d &Point)
 Make a Circle from Geom2d <TheCirc> parallel to another Circ <Circ> and passing through a Pnt <Point>.
 
 GCE2d_MakeCircle (const gp_Pnt2d &P1, const gp_Pnt2d &P2, const gp_Pnt2d &P3)
 Make a Circ from gp <TheCirc> passing through 3 Pnt2d <P1>,<P2>,<P3>.
 
 GCE2d_MakeCircle (const gp_Pnt2d &P, const Standard_Real Radius, const Standard_Boolean Sense=Standard_True)
 Make a Circ from geom2d <TheCirc> by its center an radius.
 
 GCE2d_MakeCircle (const gp_Pnt2d &Center, const gp_Pnt2d &Point, const Standard_Boolean Sense=Standard_True)
 Makes a Circle from geom2d <TheCirc> with its center

and a point giving the radius. If Sense is true the local coordinate system of the solution is direct and non direct in the other case. Warning The MakeCircle class does not prevent the construction of a circle with a null radius. If an error occurs (that is, when IsDone returns false), the Status function returns:

 
const Handle< Geom2d_Circle > & Value () const
 Returns the constructed circle. Exceptions StdFail_NotDone if no circle is constructed.
 
 operator const Handle< Geom2d_Circle > & () const
 
- Public Member Functions inherited from GCE2d_Root
Standard_Boolean IsDone () const
 Returns true if the construction is successful.
 
gce_ErrorType Status () const
 Returns the status of the construction.
 

Additional Inherited Members

- Protected Attributes inherited from GCE2d_Root
gce_ErrorType TheError
 

Detailed Description

This class implements the following algorithms used to create Circle from Geom2d.

  • Create a Circle parallel to another and passing though a point.
  • Create a Circle parallel to another at the distance Dist.
  • Create a Circle passing through 3 points.
  • Create a Circle with its center and the normal of its plane and its radius.
  • Create a Circle with its axis and radius.

Constructor & Destructor Documentation

◆ GCE2d_MakeCircle() [1/8]

GCE2d_MakeCircle::GCE2d_MakeCircle ( const gp_Circ2d & C)

creates a circle from a non persistent one.

◆ GCE2d_MakeCircle() [2/8]

GCE2d_MakeCircle::GCE2d_MakeCircle ( const gp_Ax2d & A,
const Standard_Real Radius,
const Standard_Boolean Sense = Standard_True )

A is the "XAxis" of the circle which defines the origin of parametrization. It is not forbidden to create a circle with Radius = 0.0 The status is "NegativeRadius" if Radius < 0.

◆ GCE2d_MakeCircle() [3/8]

GCE2d_MakeCircle::GCE2d_MakeCircle ( const gp_Ax22d & A,
const Standard_Real Radius )

A is the local coordinate system of the circle which defines the origin of parametrization. It is not forbidden to create a circle with Radius = 0.0 The status is "NegativeRadius" if Radius < 0.

◆ GCE2d_MakeCircle() [4/8]

GCE2d_MakeCircle::GCE2d_MakeCircle ( const gp_Circ2d & Circ,
const Standard_Real Dist )

Make a Circle from Geom2d <TheCirc> parallel to another Circ <Circ> with a distance <Dist>. If Dist is greater than zero the result is enclosing the circle <Circ>, else the result is enclosed by the circle <Circ>.

◆ GCE2d_MakeCircle() [5/8]

GCE2d_MakeCircle::GCE2d_MakeCircle ( const gp_Circ2d & Circ,
const gp_Pnt2d & Point )

Make a Circle from Geom2d <TheCirc> parallel to another Circ <Circ> and passing through a Pnt <Point>.

◆ GCE2d_MakeCircle() [6/8]

GCE2d_MakeCircle::GCE2d_MakeCircle ( const gp_Pnt2d & P1,
const gp_Pnt2d & P2,
const gp_Pnt2d & P3 )

Make a Circ from gp <TheCirc> passing through 3 Pnt2d <P1>,<P2>,<P3>.

◆ GCE2d_MakeCircle() [7/8]

GCE2d_MakeCircle::GCE2d_MakeCircle ( const gp_Pnt2d & P,
const Standard_Real Radius,
const Standard_Boolean Sense = Standard_True )

Make a Circ from geom2d <TheCirc> by its center an radius.

◆ GCE2d_MakeCircle() [8/8]

GCE2d_MakeCircle::GCE2d_MakeCircle ( const gp_Pnt2d & Center,
const gp_Pnt2d & Point,
const Standard_Boolean Sense = Standard_True )

Makes a Circle from geom2d <TheCirc> with its center

and a point giving the radius. If Sense is true the local coordinate system of the solution is direct and non direct in the other case. Warning The MakeCircle class does not prevent the construction of a circle with a null radius. If an error occurs (that is, when IsDone returns false), the Status function returns:

  • gce_NegativeRadius if Radius is less than 0.0, or
  • gce_IntersectionError if points P1, P2 and P3 are collinear and the three are not coincident.

Member Function Documentation

◆ operator const Handle< Geom2d_Circle > &()

GCE2d_MakeCircle::operator const Handle< Geom2d_Circle > & ( ) const
inline

◆ Value()

const Handle< Geom2d_Circle > & GCE2d_MakeCircle::Value ( ) const

Returns the constructed circle. Exceptions StdFail_NotDone if no circle is constructed.


The documentation for this class was generated from the following file: